DECLARE SUB clearscreen ()
REM ***************************************************************************
REM ***        Programm zur Ansteuerung der PC-Karte                        ***
REM ***                    IO 1283                                          ***
REM ***************************************************************************

REM ************************************************************************
REM ***                Hauptprogramm                                     ***
REM ************************************************************************
 
cx = 0
adresse = &H100
REM Ausgaenge auf 0 setzen
OUT adresse, 0
OUT adresse + 1, 0
 
REM Bildschirm initialisieren
CALL clearscreen
   
REM Tasten auswerten
Taste$ = "":                           REM Variable fr Taste initialisieren
DO:                                    REM in Schleife verharren    
				       REM bis Taste gedrckt
      Taste$ = INKEY$
      IF LEN(Taste$) <> 0 THEN
				       REM Wenn ja, dann           
	 LOCATE 1, 1
	 SELECT CASE RIGHT$(Taste$, 1)
	 CASE CHR$(77)
	   REM Cursor rechts
	   IF cx > 0 THEN
	     cx = cx - 1
	   ELSE
	     SOUND 1000, .4
	   END IF
	 CASE CHR$(75)
	   REM Cursor links
	   IF cx < 15 THEN
	     cx = cx + 1
	   ELSE
	     SOUND 1000, .4
	   END IF
	 CASE CHR$(13), CHR$(32)
	   REM Ausgabebit invertieren auf der der Cursor steht
	   Ausgang& = Ausgang& XOR (2 ^ cx)
	   REM An Karte ausgeben
	   OUT adresse, (Ausgang& AND 255)
	   OUT adresse + 1, ((Ausgang& / 255) AND 255)
	 END SELECT
      END IF
      REM Eingaenge lesen
      Eingang& = INP(adresse + 1)
      Eingang& = Eingang& * 256
      Eingang& = Eingang& + INP(adresse)
      REM Eingangswerte auf dem Bildschirm in der Tabelle darstellen
      FOR k = 0 TO 15:     REM alle 16 Bit
	COLOR &HE, 7:      REM Darstellung normaler Eintrag
	IF ((Eingang& AND (2 ^ k)) = 0) THEN
	  LOCATE 11, (63 - (4 * k))
	  PRINT " 0 "
	ELSE
	  LOCATE 11, (63 - (4 * k))
	  PRINT " 1 "
	END IF
      NEXT k
      REM Ausgangswerte auf dem Bildschirm in der Tabelle darstellen
      FOR k = 0 TO 15:      REM alle 16 Bit
	IF cx = k THEN
	  COLOR &HA, 2:     REM Darstellung Cursor
	ELSE
	  COLOR &HE, 7:     REM Darstellung normaler Eintrag
	END IF
	IF ((Ausgang& AND (2 ^ k)) = 0) THEN
	  LOCATE 13, 63 - (4 * k)
	  PRINT " 0 "
	ELSE
	  LOCATE 13, 63 - (4 * k)
	  PRINT " 1 "
	END IF
      NEXT k
LOOP UNTIL RIGHT$(Taste$, 1) = CHR$(68): REM Wenn F10, dann ende    
LOCATE 1, 1, 1
COLOR 0, 7
CLS
REM Ausgnge zurcksetzen
OUT adresse, 0
OUT adresse + 1, 0
END

SUB clearscreen

REM Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
REM Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
REM Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.

REM Fenster 1
rahm1$ = "ͻ"
rahm2$ = "                                                         "
rahm3$ = "ͼ"
text1$ = " ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen"
text2$ = "      Tel. 07462/7381               Fax 07462/7554       "
text3$ = ""

REM Fenster 2
rahm21$ = "ͻ"
rahm22$ = "                                                                           "
rahm23$ = " F10 = ENDE ͼ"
zeile1$ = "Ŀ"
zeile2$ = "Ĵ"
zeile3$ = ""
zeile4$ = "                                                         "
text20$ = " 15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0   Bit"

SCREEN 0
COLOR 11, 1
CLS

REM Erzeugen eines Fensters
LOCATE 2, 12, 0
COLOR 15, 7
PRINT rahm1$
LOCATE 3, 12
PRINT rahm2$
LOCATE 4, 12
PRINT rahm2$
LOCATE 5, 12
PRINT rahm3$
REM Erzeugen des Fenstertextes
COLOR 0, 7
LOCATE 3, 13
PRINT text1$
LOCATE 4, 13
PRINT text2$
REM Erzeugen des Fensterschattens
LOCATE 6, 13
PRINT text3$
LOCATE 3, 71
PRINT ""
LOCATE 4, 71
PRINT ""
LOCATE 5, 71
PRINT ""

REM Erzeugen des Ausgabefensters
LOCATE 8, 1
COLOR 15, 7
PRINT rahm21$
FOR x = 9 TO 17
  LOCATE x, 1
  PRINT rahm22$
NEXT x
LOCATE x, 1
PRINT rahm23$
REM Erzeugen des Fenstertextes
COLOR 0, 7
LOCATE 15, 2
PRINT text20$
LOCATE 10, 2
PRINT zeile1$
LOCATE 11, 2
PRINT zeile4$
LOCATE 12, 2
PRINT zeile2$
LOCATE 13, 2
PRINT zeile4$
LOCATE 14, 2
PRINT zeile3$
REM Konfiguration eintragen
LOCATE 11, 68
COLOR 4, 7
PRINT "Eingang"
LOCATE 13, 68
COLOR &HA, 7
PRINT "Ausgang"

END SUB

